C 1997/9
C          INPUT DATA SYNTHESIZING FOR F2D
C           ----- F2DSY.FOR FOR WINDOWS95 -----
C                 BY TAKAYUKI HIRAI
C
C
      COMMON NCA(32000),NCB(32000),BA(20000),BB(20000),
     1       THB(300),IPB(300),EM(300),PR(300),EMB(300),
     2       TH(300),IP(300),IA(8000),IB(8000),PRB(8000),
     3       SSG(4000),MVB(4000),NC(32000),B(20000),
     4       MVE(4000)
      CHARACTER TITLEA*40,TITLEB*40
C
C  ---------------  INPUT DATA  ---------------
      KNELE=2700
      KNODE=8000
      KNMAT=300
      IRR=0
      OPEN(15,FILE='DA',STATUS='OLD')
      OPEN(25,FILE='DB',STATUS='OLD')
      OPEN(16,FILE='DD')
      READ(15,1001) TITLEA 
      WRITE(*,2001) TITLEA
      READ(15,1002) NELEA,NODVA,NODEA,NMATA,NGA,NONC
      IF(NONC.NE.0) NONC=1
      IF(NELEA*(KNELE-NELEA+1).LE.0) IRR=20000
      IF(NODEA*(KNODE-NODEA+1).LE.0) IRR=30000
      IF(NMATA*(KNMAT-NMATA+1).LE.0) IRR=10000
      IF((NGA-2)*(6-NGA).LE.0.0) IRR=15000
      IF(IRR.NE.0) GO TO 403
      READ(15,1001) TITLEB
      DO 19 I=1,NODEA
   19 READ(15,1003) N,BA(I*2-1),BA(I*2)
      READ(15,1001) TITLEB
      DO 10 I=1,NELEA
      READ(15,1004) N,(NCA(I*8-8+J),J=1,8),MVE(I),
     1   SSG(I)
      DO 12 J=1,7
      JJ=J+1
      DO 12 K=JJ,8
   12 IF(NCA(I*8-8+J).EQ.NCA(I*8-8+K)) IRR=50000+I     
   10 CONTINUE
      READ(15,1001) TITLEB
      DO 11 I=1,NMATA
      READ(15,1005) N,EM(I),PR(I),TH(I),IP(I)
      IF(IP(I).EQ.1) EM(I)=EM(I)/(1.0-PR(I)**2)
      IF(IP(I).EQ.1) PR(I)=PR(I)/(1.0-PR(I))
      IF(ABS(PR(I)**2-1.0).LT.0.0001) IRR=11000+I
   11 IF(IRR.NE.0) GO TO 403
 1001 FORMAT(15X,A40) 
 1002 FORMAT(15X,I5)
 1003 FORMAT(I5,2F15.6)
 1004 FORMAT(10I5,F10.5)
 1005 FORMAT(I5,3F15.1,I5)
      READ(25,1001) TITLEB 
      WRITE(*,2041) TITLEB
      READ(25,1002) NELEB,NODVB,NODEB,NMATB,NGA,NONC
      IF(NELEB*(KNELE-NELEB+1).LE.0) IRR=20000
      IF(NODEB*(KNODE-NODEB+1).LE.0) IRR=30000
      IF(NMATB*(KNMAT-NMATB+1).LE.0) IRR=10000
      IF((NGA-2)*(6-NGA).LE.0.0) IRR=15000
      IF(IRR.NE.0) GO TO 403
      READ(25,1001) TITLEB
      DO 29 I=1,NODEB
   29 READ(25,1003) N,BB(I*2-1),BB(I*2)
      READ(25,1001) TITLEB
      DO 20 I=1,NELEB
      READ(25,1004) N,(NCB(I*8-8+J),J=1,8),MVB(I),
     1   SSG(I+NELEA)
      DO 22 J=1,7
      JJ=J+1
      DO 22 K=JJ,8
   22 IF(NCB(I*8-8+J).EQ.NCB(I*8-8+K)) IRR=50000+I     
   20 CONTINUE
      READ(25,1001) TITLEB
      DO 21 I=1,NMATB
      READ(25,1005) N,EMB(I),PRB(I),THB(I),IPB(I)
      IF(IPB(I).EQ.1) EMB(I)=EMB(I)/(1.0-PRB(I)**2)
      IF(IPB(I).EQ.1) PRB(I)=PRB(I)/(1.0-PRB(I))
      IF(ABS(PRB(I)**2-1.0).LT.0.0001) IRR=11000+I
   21 IF(IRR.NE.0) GO TO 403
 2001 FORMAT(/'           START     TITLEA = ',A40)
 2041 FORMAT('           START     TITLEB = ',A40)
C
C   ----------- SYNTHESIZING DATA -----------
      DO 130 I=1,NODEA
      B(I*2-1)=BA(I*2-1)
  130 B(I*2)=BA(I*2)
      DO 131 I=1,NELEA
      DO 131 J=1,8
  131 NC(I*8-8+J)=NCA(I*8-8+J)
      I4=NODEA
      DO 101 J=1,NODEB
      DO 108 I=1,NODEA
      IF (ABS(BA(I*2-1)-BB(J*2-1)).GT.0.00001) GO TO 108
      IF (ABS(BA(I*2)-BB(J*2)).GT.0.00001) GO TO 108
      IB(J)=I
      GO TO 101
  108 CONTINUE
      I4=I4+1
      IB(J)=I4
      B(I4*2-1)=BB(J*2-1)
      B(I4*2)=BB(J*2)
  101 CONTINUE
      NELE=NELEA+NELEB
      NODE=I4
      NMAT=NMATA+NMATB
      DO 211 I=1,NELEB
      DO 212 J=1,8
  212 NC((I+NELEA)*8-8+J)=IB(NCB(I*8-8+J))
  211 MVE(I+NELEA)=MVB(I)+NMATA
      DO 231 I=1,NMATB
      EM(NMATA+I)=EMB(I)
      PR(NMATA+I)=PRB(I)
      TH(NMATA+I)=THB(I)
  231 IP(NMATA+I)=IP(I)
      I4=2
      IB(1)=NC(1)
      IB(2)=NC(2)
      DO 140 I=1,NELE
      DO 140 J=1,4
      DO 142 K=1,I4
      IF(NC(I*8-8+J).EQ.IB(K)) GO TO 140
  142 CONTINUE
      I4=I4+1
      IB(I4)=NC(I*8-8+J)
  140 CONTINUE
      NODV=I4
      WRITE(16,2002) TITLEA 
      WRITE(16,2031) NELE
      WRITE(16,2032) NODV
      WRITE(16,2033) NODE
      WRITE(16,2034) NMAT
      WRITE(16,2035) 
      WRITE(16,2036) 
      WRITE(16,2037) 
      DO 301 I=1,NODE 
  301 WRITE(16,2014) I,B(I*2-1),B(I*2)
 2002 FORMAT(' MODEL TITLE  =',A40)
 2006 FORMAT(/)
 2014 FORMAT(I5,2F15.6)      
 2031 FORMAT('ELEMENTS      =',I5)
 2032 FORMAT('VERTEX NODES  =',I5)
 2033 FORMAT('TOTAL NODES   =',I5)
 2034 FORMAT('MATERIALS     =',I5)
 2035 FORMAT('GAUSS POINTS  =    3')
 2036 FORMAT('CON.=1 NON.=0 =    1')
 2037 FORMAT('  NODE   CO-ORDINATE X-Y')
      WRITE(16,2040)
      DO 302 I=1,NELE
  302 WRITE(16,2015) I,(NC(J+I*8-8),J=1,8),MVE(I),
     1   SSG(I)
      WRITE(16,2016)
      DO 304 I=1,NMAT
  304 WRITE(16,2021) I,EM(I),PR(I),TH(I),IP(I)
      WRITE(16,2018)
      DO 441 I=1,3
  441 WRITE(16,2017)
      WRITE(16,2081)
 2040 FORMAT(' ELEMENT  NODE NUMBER 1-8',
     1   21X,'MAT.   INI. STRAIN')
 2015 FORMAT(10I5,F10.5)
 2016 FORMAT(' MATERIAL  YOUNG''S R.    POISSON''S ',
     1   'R.   THICKNESS  PLANE STRESS=0/STRAIN=1')
 2021 FORMAT(I5,3F15.6,I5)
 2018 FORMAT(' NODE  CONDITION X-Y   NODE CONDITION',
     1   ' VALUE X-Y')
 2017 FORMAT('    1    0    0       0.000000      '
     1   ,' 0.000000')
 2081 FORMAT('99999')
  403 IF(IRR.EQ.0) WRITE(*,2055) 
      IF(IRR.NE.0) WRITE(*,2056) IRR 
 2055 FORMAT('      ----- DATA IS SYNTHESIZED -----')
 2056 FORMAT('      ----- DATA ERROR -----   IRR =',I6)
      CLOSE(16,STATUS='KEEP')
      CLOSE(15,STATUS='KEEP')
      CLOSE(25,STATUS='KEEP')
      STOP
      END
